plot.experiment.time.point.correlations<- function(corrmx){
  par(mar=c(1,0,4,2)+.1)
  library(fields)
  extra<- numexps/16*1.5
  extra2<- numexps/4
  dc<-dim(obsns)[2]+1
  for( j in 2:(dc-1) ){ for( i in 1:(j-1) ){ corrmx[i,j]<-NA }}
  image.plot(c(-extra,seq(0,numexps,length=dc)),c(seq(0,numexps,length=dc),numexps+extra2),cbind(rbind(rep(NA,dc-1),corrmx[,(dc-1):1]),rep(NA,dc)),axes=F,xlab="",ylab="")
  pos<-0
  post<-0
  for( i in 1:numexps ){
    pos<-pos+length(xmx[[i]])/length(xs)*numexps
    post<-pos-length(xmx[[i]])/length(xs)*numexps/2
    text(post-extra,numexps-post,expnames[i],cex=1)
    text(post,numexps+extra2/2,expnames[i],srt=90,cex=1)
    if( i < numexps ){
      lines(c(pos,pos),c(numexps-pos,1e100))
      lines(c(pos-extra,1e100),c(numexps-pos,numexps-pos))
#    lines(c(numexps-pos-extra,1e100),c(pos,pos))
    }
  }
}


my.median<-function(x){
  if(sum(!is.na(x))==0){NA}else{
    median(x,na.rm=T)}
}
my.quantile<-function(x){
  if(sum(!is.na(x))==0){rep(NA,5)}else{
    quantile(x,na.rm=T,names=F)}
}

library(fields)
plotpoints<-1
plotfittedcurve<-1*0
predict.on.data<-!FALSE
plottofile<-1
set.seed(0)
horizontalplots<-TRUE
imagealltogether<-1
onepageplottofile<-0
rawplot<-0
missingplot<-1*0
pointcolor<-"black"
pointcex<-.75
jpgrawplot<-1#if 1, put raw plot in its own jpeg
jpgmissingplot<-1#if 1, put missing values matrix plot in its own jpeg
heatplot<-1
medianplot<-TRUE
bicplot<-1
exp.names.on.plot<-1
plots.on.same.scale<-!TRUE
associations<-1
crosscorrelations<-0
plotlabelledgenes<-0
outliersmarked<-0+1*0
plotbayesfactors<-0
loginputs<-0
homedir<-"./"
thisdir<-"./"
partic<-scan(paste(paste(homedir,thisdir,sep=""),"currentfile.txt",sep=""),
what=character())
mxpw<-1
#mxpw<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_currentpowevar.dat",sep=""))[1]
dataname<-""#paste(partic,", ",sep="")
#numclust<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_numclust.dat",sep=""))
xs<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_x.txt",sep=""))
dbs<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_data_block_sizes.dat",sep=""))
cumdbs<-cumsum(dbs)
ndbs<-length(dbs)
dbis<-NULL
for( i in 1:ndbs ){ dbis<-c(dbis,rep(i,dbs[i]+1)) }
xmx<-list(xs[1:cumdbs[1]])
for( i in 2:ndbs ){ xmx<-c(xmx,list(xs[(cumdbs[i-1]+1):cumdbs[i]])) }
timelabel<-timelabel1<-"Time"
timelabel2<-"Replicates"
if(loginputs){ xs<-log(xs+1); timelabel="log(Time)" }
lxs<-length(xs)
uxs<-unique(xs)
luxs<-length(uxs)
reps<-lxs/luxs*0
xmax<-max(xs)
xmin<-min(xs)
xmaxs<-xmins<-rep(NA,ndbs)
for( i in 1:ndbs ){
   xmaxs[i]<- max(xmx[[i]])
   xmins[i]<- min(xmx[[i]])
}
cluster.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_clusters_.dat",sep="")
if( !file.exists(cluster.file) ){
  cluster.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".txt",sep="")
}
ys<-scan(cluster.file)
n<-length(ys)/sum(dbs+1)
ycols<-max(dbs)+1
allys<-matrix(NA,n*ndbs,ycols)

missing.values<-missing<-NULL
missing.colors<-NULL
missing.file<- paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_cluster_missing_values_.dat",sep="")
if( file.exists(missing.file) ){
   missing.values<-scan(missing.file)
   missing<-matrix(NA,nrow=n*ndbs,ncol=ycols-1)
#   missing<-matrix(missing.values,nrow=n*ndbs,ncol=ycols-1)
#   missing.sums<-apply(missing,1,sum,na.rm=T)
}
basis.powers<-NULL
basispowers.file<- paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_basis_powers.dat",sep="")
if( file.exists(basispowers.file) ){
   basis.powers<-matrix(scan(basispowers.file),byrow=T,ncol=3)
}

cluster.subjects<-NULL
cluster_subjects.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_cluster_subjects_.dat",sep="")
if( file.exists(cluster_subjects.file) ){
   cluster.subjects<-scan(cluster_subjects.file)+1
}


counter<-counter2<-1
for( i in 1:(n*ndbs) ){
  expt<-(i-1)%%ndbs+1
  rowlength<-dbs[expt]+1
  allys[i,1:rowlength]<-ys[counter:(counter+rowlength-1)]
  if( !is.null(missing) ){
     missing[i,1:(rowlength-1)]<-missing.values[counter2:(counter2+rowlength-2)]
     counter2<-counter2+rowlength-1
  }
  counter<-counter+rowlength
}
#allys<-read.table(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".txt",sep=""));ycols<-dim(allys)[2]
if( !is.null(missing) ){
  missing.sums<-apply(missing,1,sum,na.rm=T)
  obsn.has.missing.data<-rep(apply(matrix(missing.sums,ncol=ndbs,byrow=T),1,sum,na.rm=T) > 0, each=ndbs)
  num.obsns.having.missing.data<-sum(obsn.has.missing.data)
}


bigpreds<-matrix(scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds_",sep=""),".dat",sep="")), byrow=T, ncol=3)
numallys<-dim(allys)[1]
numclust<-max(allys[,1])
biggesty<-max(allys[1:numallys,2:ycols],na.rm=TRUE)
smallesty<-min(allys[1:numallys,2:ycols],na.rm=TRUE)
#smallesty<-min(smallesty,-biggesty)
#biggesty<-max(-smallesty,biggesty)
expnumbers.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_exp_numbers_.dat",sep="")
if( file.exists(expnumbers.file) ){
  exps<-scan(expnumbers.file)
  numexps<-max(exps)
  minexps<-min(exps)
  if( minexps != numexps ){ numexps <- numexps - minexps + 1 }
}else{
  numexps<-ndbs
}
expnames<-paste(rep("Variable ",numexps),1:numexps)
if( file.exists("allfiles.txt") ){
  expnames<-scan("allfiles.txt", what=character(),sep="\n")
}
separateexperiments<-1
if( numexps == 1 ){ separateepxeriments<-0 }

votes<-NULL
votes.file<- paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_votes_.dat",sep="")
if( file.exists(votes.file) ){votes<-matrix(scan(votes.file),ncol=numexps,byrow=T)}

obsns<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".dat",sep="")),byrow=T,ncol=lxs)
numobsns<-dim(obsns)[1]
ymaximum<-max(biggesty,bigpreds[,2])
yminimum<-min(smallesty,bigpreds[,2])
#smallesty<-yminimum
#biggesty<-ymaximum
if( numclust/numexps <= 40 ){ clusterlinesonimage<-1 }else{ clusterlinesonimage<-0 }
dendro<-1
#  RESIDUALS STUFF:
  res<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_residuals_.dat",sep=""))
  if( is.null(missing) )
  {
    mres<-matrix(res,byrow=T,ncol=lxs)
  }else
  {
    mres<-matrix(NA,ncol=lxs,nrow=dim(allys)[1])
    counter<-0
    for(i in 1:(dim(allys)[1]/numexps)){
      for( j in 1:(lxs-sum(missing.sums[(numexps*(i-1)+1):(numexps*i)])) ){
        mres[i,j]<-res[counter+j]
      }
      counter<-counter+(lxs-missing.sums[i])
    }
  }
  ssq<-apply(mres*mres,1,sum,na.rm=T)
  if( !is.null(missing) ){
    ssq<-ssq/(lxs-missing.sums)
  }
  odr<-order(ssq,decreasing=T)
  if( plotbayesfactors ){
    bfs<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_bayes_factors_.dat",sep="")),ncol=2,byrow=T)
    logbayesfactors<-bfs[,2]-bfs[,1]
    odr2<-order(logbayesfactors,decreasing=T)
  }
  numoutliersmarked<-15

partition<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_partition_.dat",sep=""))

error.covs<-NULL
error.covs.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_cluster_error_covariances_.dat",sep="")
if( file.exists(error.covs.file) ){
  error.covs<-matrix(scan(error.covs.file),ncol=cumdbs[ndbs],byrow=T)
}

#grred <-c("green4","green3","green2","green1","green","darkgreen","black","darkred","red","red1","red2","red3","red4")
grred<-c("#00FF00", "#00F400", "#00EA00", "#00DF00", "#00D400", "#00CA00", "#00BF00", "#00B500", "#00AA00", "#009F00", "#009500", "#008A00", "#008000", "#007500", "#006A00", "#006000", "#005500", "#004A00", "#004000", "#003500", "#002A00", "#002000", "#001500", "#000B00", "#000000", "#000000", "#0B0000", "#150000", "#200000", "#2A0000", "#350000", "#400000", "#4A0000", "#550000", "#600000", "#6A0000", "#750000", "#800000", "#8A0000", "#950000", "#9F0000", "#AA0000", "#B50000", "#BF0000", "#CA0000", "#D40000", "#DF0000", "#EA0000", "#F40000", "#FF0000")

if(plottofile)
{	
  psname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds.ps",sep="")
  pdfname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds.pdf",sep="")
#  postscript(psname,horizontal=horizontalplots)
  pdf(pdfname,width=14,height=10,title=paste(partic,"results"))#,horizontal=horizontalplots)
##  pdf(pdfname,width=10,height=12,horizontal=horizontalplots)
}

par(mfrow=c(1,1))
op <- par(no.readonly = TRUE)

if(!plottofile || onepageplottofile)
{
  if( numclust < 4 )
  {
    par(mfrow=c(numclust,1))
  }
  else
  {
    rows <- ceiling(sqrt(numclust))
#    cols <- floor(sqrt(numclust))+2
    if( rows^2 != numclust ){ rows<- rows - 1 }
    cols <- ceiling(numclust/rows)
    par(mfrow=c(rows,cols))
  }
}


if( numexps < 4 ){
  rows <- 1
  cols <- numexps
}else if( numexps == 4 || numexps == 9 ){
  rows <- cols <- sqrt(numexps)
}else{
  rows <- ceiling(sqrt(numexps))-1
  cols <- floor(sqrt(numexps))+2
  cols <- ceiling(numexps/rows)
}
par(mfrow=n2mfrow(numexps))#c(rows,cols))
if( horizontalplots ){ par(mfrow=c(cols,rows)) }

if(rawplot){
  if(jpgrawplot){
    jpgname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_raw.jpg",sep="")
    jpeg(jpgname,height=1350,width=1800,quality=100)
  }
  par(mfrow=c(rows,cols))
  if( horizontalplots ){ par(mfrow=c(cols,rows)) }
  numindices<-numallys
  indices<-seq(from=1,to=numindices,length=numindices)
  for( expt in 1:numexps ){
    xs.e<-xmx[[expt]]; lxs.e<-length(xs.e)
    plot(xs.e,allys[indices[expt],2:(lxs.e+1)],xlim=c(xmin,xmax),ylim=c(smallesty,biggesty),col=1,xlab=timelabel,ylab="Expression",type='b',pch=16,cex=.5,lty=3,lwd=1)
    for( i in 1:(numallys/numexps) ){
      
      if(!is.null(missing)){pointcolor<-ifelse(missing[indices[i*numexps+expt],],"red","black")}
      points(xs.e,allys[indices[i*numexps+expt],2:(lxs.e+1)],pch=16,cex=.5,col=pointcolor)
      lines(xs.e,allys[indices[i*numexps+expt],2:(lxs.e+1)],lty=3,lwd=1,col=i)
      if( reps )for( j in 0:(reps-1) ){
        start<-2+j*luxs
        end<-2+(j+1)*luxs-1
        lines(uxs,allys[indices[i*numexps+expt],start:end],lty=3,lwd=1)
      }
    }
    title(expnames[expt])
  }
  if(jpgrawplot){ dev.off() }

#  numindices<-numallys/numexps
#  indices<-seqs(from=1,to=numindices,length=numindices)
#  indices<-sample(numallys/numexps,numindices,replace=FALSE)*numexps-(numexps-1
#  jumbledys<-allys
#  counter<-0
#  for( i in 1:(numallys/numexps) ){
#    for( j in 1:numexps ){
#      counter<-counter+1
#      jumbledys[counter,]<-allys[indices[i]+j-1,]
#    }
#  }
}

if(missingplot){
  orig.missing.file<- paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_missing_values.dat",sep="")
  if( file.exists(orig.missing.file) ){
    orig.missing.values<-matrix(scan(orig.missing.file),nrow=n,byrow=T)
    if(jpgmissingplot){
      jpgname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_missing_values.jpg",sep="")
      jpeg(jpgname,height=1350,width=1800,quality=100)
    }
    par(mar=c(4,0.5,0,0))
#   plot(NA,xlim=c(0,n),ylim=c(0,dim(orig.missing.values)[2]))
#   for( j in 1:dim(orig.missing.values)[2] ){
#     for( i in 1:n ){
#       if( orig.missing.values[i,j]){points(i-.5,j-.5)}
#     }
#   }
   blank.rows<-80
   image(0:(n+blank.rows),0:dim(orig.missing.values)[2],rbind(orig.missing.values,matrix(NA,blank.rows,dim(orig.missing.values)[2])),col=c("white","black"),xlab='Genes',ylab='',axes=F)
   axis(1)
   expcol<-"blue"
   hgt<-cumdbs[1]/2
   for( i in 1:ndbs){
    abline(h=cumdbs[i],lty=3,col=expcol,lwd=1.5)
    text(n+blank.rows/2,hgt,expnames[i],srt=0,cex=1,adj=.5,srt=0,col=expcol)
    if(i<ndbs){hgt<-hgt+(dbs[i]+dbs[i+1])/2}
   }
   if(jpgmissingplot){dev.off()}
  }
}

nlabgs<-0
if(plotlabelledgenes){
  labgs<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_labelled_genes_.dat",sep=""))
  nlabgs<- length(labgs)
  for( expt in 1:numexps ){
    plot(xs,obsns[labgs[1],((expt-1)*lxs+1):(expt*lxs)],xlim=c(xmin,xmax),ylim=c(smallesty,biggesty),col=1,xlab=timelabel,ylab="Expression",type='b',pch=16,cex=.5,lty=3,lwd=1)
    for( i in 1:nlabgs )
      {
        points(xs,obsns[labgs[i],((expt-1)*lxs+1):(expt*lxs)],pch=16,cex=.5,col=i)
        for( j in 0:(reps-1) ){
          start<-(expt-1)*lxs+1+j*luxs
          end<-(expt-1)*lxs+1+(j+1)*luxs-1
          lines(uxs,obsns[labgs[i],start:end],lty=3+floor(i/10),lwd=1,col=i)
        }
      }
    title(expnames[expt])
  }
}
  
is<-seq(from=1,to=numclust,length=numclust)
#is<-c(2,3,5,6,1,4,7)
#is<-c(2,1)
missingmx<-NULL
ysempty <- TRUE
quantiles<-NULL
if(predict.on.data && dim(bigpreds)[1]/numclust*numexps != lxs ) predict.on.data=FALSE;
predrows<-dim(bigpreds)[1]/numclust
preds<-matrix(nrow=predrows,ncol=3)
predrowcounter<-0
plotclusterseparately<-0
plotclusteringimageseparately<-0
plotclusteringmediansseparately<-0
plotbicseparately<-0



labelled.indicator<-rep(FALSE,n)
if( nlabgs > 0 ){ labelled.indicator[labgs]<-TRUE }
if(!is.null(cluster.subjects)){
  labelled.indicator<-labelled.indicator[cluster.subjects]
}
labelled.indicator<-rep(labelled.indicator,each=ndbs)

if( !nlabgs && !is.null(missing) ){
  labelled.indicator<-obsn.has.missing.data
  nlabgs<-num.obsns.having.missing.data
}

par(omi=c(0,0,0.5,0) )                      #set the size of the outer margins
par(mar=c(4,4,3,0))
for( ii in 1:length(is) )
{
	i <- is[ii]
        if( !separateexperiments ){
          expt <- 1
          clstr <- i
        }else{
          expt <- i - (ceiling( i / numexps )-1) * numexps
          clstr <- ceiling( i / numexps )
        }
        numobs<-length(allys[allys[,1]==i,1])
        rainbow.vector<-rainbow(numobs)
#	numobs<-length(scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),i,sep=""),".dat",sep="")))/lxs
        if(predict.on.data){
          predrows<-length(xmx[[expt]])
          preds<-matrix(nrow=predrows,ncol=3)
        }
        for( j in 1:predrows ){
          preds[j,] <-bigpreds[predrowcounter+j,]
        }
        predrowcounter<-predrowcounter+predrows
#	preds<-matrix(scan(paste(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds_",sep=""),i,sep=""),".dat",sep="")) , byrow=T,ncol=3)
	ymax <- 0
        ymin <- 0
	if( numobs > 1 )
	{
		ymax<-max(preds)
		ymin<-min(preds)
	}
	if( is.nan( ymax ) || is.nan( ymin ) || numobs <= 1 )
	{
		ymax<-max(preds[,2])
		ymin<-min(preds[,2])
	}
	if(plotpoints)
	{
	        iindices<-allys[,1]==i
		ymx<-matrix(allys[iindices,2:ycols],ncol=ycols-1)
#                ymx<-matrix(scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),i,sep=""),".dat",sep="")),byrow=T,ncol=length(xs))
		ymax<-max(c(ymax,max(ymx,na.rm=TRUE)))
		ymin<-min(c(ymin,min(ymx,na.rm=TRUE)))
		if(!is.null(missing)){missingmx<-matrix(missing[iindices,],ncol=ycols-1)}
                labelled.vec<-labelled.indicator[iindices]
	}
        
	if( expt == 1 ){
	   par(mfrow=c(rows,cols))
	   if( horizontalplots ){ par(mfrow=c(cols,rows)) }
           if( clstr == plotclusterseparately ){
#            jpeg(paste(paste("cluster_",clstr,sep=""),".jpg",sep=""),height=1200,width=900)
#             png(paste(paste("cluster_",clstr,sep=""),".png",sep=""),height=900,width=1200)
             pdf(paste(paste("cluster_",clstr,sep=""),".pdf",sep=""),height=9,width=12)
             par(omi=c(0,0,0.5,0),mfrow=c(cols,rows),mar=c(4,4,3,0) )
           }
	}
        if(is.null(missingmx)){
          ymxi<-matrix(ymx[,1:length(xmx[[expt]])],nrow=dim(ymx)[1])}else{
            ymxi<-matrix(ifelse(missingmx==0,ymx,NA),nrow=dim(ymx)[1])}
        ymxi<-ymxi[,1:length(xmx[[expt]])]
        if(numobs==1){quantile.i<-matrix(rep(ymxi,5),nrow=5,byrow=T)}else{
         quantile.i<-apply(ymxi,2,my.quantile)}
        quantiles<-cbind(quantiles,quantile.i)
        lpredxs<-length(preds[,2])
#        predxs<-seq(from=min(xmx[[expt]]),to=max(xmx[[expt]]),length=lpredxs)
        predxs<-seq(xmin,xmax,length=lpredxs)
        if(!is.null(basis.powers)){mxpw<-basis.powers[expt,2]}
        if( mxpw != -1 ){
          predxsindices<-1:lpredxs
	  timelabel<-timelabel1
        }else{
#          predxsindices.new<-(xmx[[expt]]-xmins[expt])/(xmaxs[expt]-xmins[expt])*(lpredxs-1)+1
          predxsindices<-(xs-xmin)/(xmax-xmin)*(lpredxs-1)+1
          predxs<-predxs[ predxsindices ]
	  timelabel<-timelabel2
        }
	predxsindices<-predxsindices[as.logical((predxs>=xmins[expt])*(predxs<=xmaxs[expt]))]
	predxs<-predxs[as.logical((predxs>=xmins[expt])*(predxs<=xmaxs[expt]))]
        if(predict.on.data){
          predxs<-xmx[[expt]]
          predxsindices<-1:length(predxs)
          predxs<-predxs[predxs>=xmin&&predxs<=xmax]
        }

                                        #	plot(seq(from=xmin,to=xmax,length=length(preds[,2])), preds[,2],type='l',ylim=c(ymin,ymax),col=1,xlab="time",ylab="expression")
	ylimits<-c(smallesty,biggesty)
	if(!plots.on.same.scale){ylimits<-c(min(ymx,na.rm=T),max(ymx,na.rm=T))}
#	print(ylimits)
	plot(NA,type='l',xlim=c(xmins[expt],xmaxs[expt]),ylim=ylimits,col=1,xlab=timelabel,ylab="Expression",lwd=.1,bty='l',xaxt=ifelse(mxpw!=-1,"s","n"))
        if(mxpw==-1) axis(1,xmins[expt]:xmaxs[expt])
        abline(h=0)
#	titlei<-paste(partic, paste(", Cluster ",i,sep=""),sep="")
        titlei<-dataname
	if( !separateexperiments )
	{
            clstr <- i
            expt <- 1
#	    titlei<-paste(dataname, paste("Cluster ",i,sep=""),sep="")
	}else
	{
	    clstr <- ceiling( i / numexps )
	    expt <- i - (clstr-1) * numexps
#	    titlei<-paste(titlei, paste(dataname, paste("Cluster",clstr,sep=""),sep=""), ", ", sep="")
#	    titlei<-paste(titlei, paste("Expt. ",expt,sep=""),sep="")
            titlei<-paste(titlei, expnames[ expt ] )
	}
#	if(ii<5){titlei<-"Anapholes"}else{titlei<-"Plasmodium"}
	title2i<-paste(' (', paste(numobs,' subjects)',sep=""),sep="")#obsns.
	title3i<-titlei#paste(titlei,title2i,sep="")
	if(!is.null(missingmx)){
	  missingtitle<-paste(' (', paste(sum(missingmx,na.rm=T),' missing values.)',sep=""),sep="")
	  title3i<-paste(title3i,missingtitle,sep="")
	}
	if(!is.null(votes) && votes[clstr,expt] ){
	  title3i<-paste(title3i,"*",sep=" ")
	}
	title(title3i)
        cluster.title<-"Cluster"
        if( expt == 1 ){mtext(paste(paste(cluster.title,clstr),title2i,sep=""),3,outer=TRUE,line=1,cex=1.5)}
	if(plotpoints)
	{
          nys <- length(ymx[,1])
          for( j in 1:nys )
            {
	      xmx.j<- xmx[[expt]][!is.na(ymx[j,])]
	      ymx.j<- ymx[j,!is.na(ymx[j,])]
	      if(!is.null(missing)){
	        missingmx.j<- missingmx[j,!is.na(missingmx[j,])]
#		xmx.j<-xmx.j[missingmx.j==0]
#		ymx.j<-ymx.j[missingmx.j==0]
	        pointcolor<-ifelse(missingmx.j,"red","black")
                pointcex<-ifelse(missingmx.j,2,.75)
	      }
              points(xmx.j,ymx.j,pch=16,cex=pointcex,col=ifelse(nlabgs>0,ifelse(labelled.vec[j],rainbow.vector[j],'black'),rainbow.vector[j]))#.5,lty=3,col=pointcolor)
              lines(xmx.j,ymx.j,lty=ifelse(mxpw != -1,1,3),lwd=ifelse(labelled.vec[j],2,1),col=ifelse(nlabgs>0,ifelse(labelled.vec[j],rainbow.vector[j],'black'),rainbow.vector[j]))
            }
	}

#        if( nlabgs > 0 ){
#          for( i in 1:nlabgs ){
#            if( partition[labgs[i]] == clstr ){
#              xmx.j<- xmx[[expt]][!is.na(ymx[j,])]
#	      ymx.j<- ymx[j,!is.na(ymx[j,])]
#
#                lines(uxs,obsns[labgs[i],start:end],lty=6,lwd=1,col='green')
#            }
#          }
#        }
        
	if( plotfittedcurve && mxpw != -1 ){
          if( !is.nan( max(preds[predxsindices,1]) ) && !is.nan( min(preds[predxsindices,3]) ) )
            {
              lines(predxs,preds[predxsindices,1],col=5,lwd=1)
              lines(predxs,preds[predxsindices,3],col=5,lwd=1)
            }
          lines(predxs,preds[predxsindices,2],col=4,lwd=3)
        }

        if( outliersmarked ){
          for( i in 1:numoutliersmarked ){
            if( partition[odr[i]] == clstr ){
                end<-cumdbs[expt]
                start<-end-dbs[expt]+1
                obsnsrow<- obsns[odr[i],start:end]
                lines(xmx[[expt]],obsns[odr[i],start:end],lty=3,lwd=3,col='gold')
            }
#             if( partition[odr[numobsns+1-i]] == clstr ){
#               for( jj in 0:(reps-1) ){
#                 start<-(expt-1)*lxs+1+jj*luxs
#                 end<-(expt-1)*lxs+1+(jj+1)*luxs-1
#                 lines(uxs,obsns[odr[numobsns+1-i],start:end],lty=3,lwd=3,col='orange')
#               }
#             }
            if( plotbayesfactors && partition[odr2[i]] == clstr ){
              for( jj in 0:(reps-1) ){
                start<-(expt-1)*lxs+1+jj*luxs
                end<-(expt-1)*lxs+1+(jj+1)*luxs-1
                lines(uxs,obsns[odr2[i],start:end],lty=3,lwd=3,col='red')
              }
            }
            if( plotbayesfactors && partition[odr2[numobsns+1-i]] == clstr ){
              for( jj in 0:(reps-1) ){
                start<-(expt-1)*lxs+1+jj*luxs
                end<-(expt-1)*lxs+1+(jj+1)*luxs-1
                lines(uxs,obsns[odr2[numobsns+1-i],start:end],lty=3,lwd=3,col='purple')
              }
            }
          }
        }

	if( plotpoints && nys > 1 ){
		if( ysempty ){
                        ysempty <- FALSE
			ys <- ymx}
		else{
			ys <- rbind( ys, ymx )}
		n <- 10
		#image(seq(from=1,to=nys,length=nys),xs,ymx,xlab='genes', ylab ='time',col=grred,zlim=c(smallesty, biggesty))
		
	}
        if( expt == numexps && !is.null(error.covs)){
          par(omi=c(0,0,0.5,0),mfrow=c(1,1),mar=c(4,4,3,0) )
          error.corr.clstr<-error.cov.clstr<-error.covs[((clstr-1)*cumdbs[ndbs]+1):(clstr*cumdbs[ndbs]),]
          for( i in 1:cumdbs[ndbs] ){
            error.corr.clstr[i,i]<-1
            for( j in 1:(i-1) ){
               error.corr.clstr[i,j]<-error.corr.clstr[j,i]<-error.cov.clstr[i,j]/sqrt(error.cov.clstr[i,i]*error.cov.clstr[j,j])
            }
          }
          plot.experiment.time.point.correlations( error.corr.clstr )
#          image.plot(error.corr.clstr[cumdbs[ndbs]:1,],xlab="",ylab="",axes=F)
          title(paste(paste("Cluster",clstr),"residual time point correlations"))
          par(omi=c(0,0,0.5,0),mfrow=c(cols,rows),mar=c(4,4,3,0) )
        }
        if( clstr == plotclusterseparately && expt == numexps ){ dev.off() }
}


if( !is.null(error.covs)){
  par(omi=c(0,0,0.5,0),mfrow=c(1,1),mar=c(4,4,3,0) )
  dim1<-dim(error.covs)[1]
  error.corr.glob<-error.cov.glob<-error.covs[(dim1-cumdbs[ndbs]+1):dim1,]
  for( i in 1:cumdbs[ndbs] ){
    error.corr.glob[i,i]<-1
    for( j in 1:(i-1) ){
      error.corr.glob[i,j]<-error.corr.glob[j,i]<-error.cov.glob[i,j]/sqrt(error.cov.glob[i,i]*error.cov.glob[j,j])
    }
  }
  plot.experiment.time.point.correlations( error.corr.glob )
#  image.plot(error.corr.glob[cumdbs[ndbs]:1,],xlab="",ylab="",axes=F)
  title("Global residual time point correlations")
}

par(op)
if( imagealltogether )
{
  if(plotclusteringimageseparately){
    png(paste(partic,"_clustering_image.png",sep=""),height=900,width=1200)
  }
#  ys<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".txt",sep="")),byrow=T,ncol=length(xs)+1)
#  ys<-ys[,2:length(xs)+1]
  matrixofys<-allys[,2:ycols]
  matrixofys<-matrix(t(matrixofys),byrow=T,ncol=(ycols-1))
  nys <- dim(matrixofys)[1]/numexps
  ysrk<-rank(t(matrixofys))
  ysrk[ysrk>sum(!is.na(matrixofys))]<-NA
  ysrk<-t(matrix(ysrk,ncol=nys*numexps))
  ysrkcp<-ysrk
  ysrk<-as.vector(t(ysrk))
  ysrk<-ysrk[!is.na(ysrk)]
  if(!is.null(missing.values)){ ysrk[missing.values==1]<-NA }
  ysrk<-matrix(ysrk,byrow=T,nrow=nys)
  if( dendro ){ ysrk<-cbind(ysrk,matrix(NA,nys,1))}#length(xmx[[1]]))) }
  x.multiplier<-1
  concxs<-xmx[[1]]
  if( xmx[[2]][1] ){xshift<-0}else{xshift<-(xmx[[2]][2]-xmx[[2]][1])}
  shiftsum<-max(xmx[[1]])+xshift
  if( numexps > 1 ){
    for( i in 2:numexps ){
      if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
      concxs<-c(concxs, shiftsum+xmx[[i]]*x.multiplier)
      if( i < numexps ){ if( xmx[[i+1]][1] ){xshift<-0}else{xshift<-(xmx[[i+1]][2]-xmx[[i+1]][1])} }
      shiftsum <- shiftsum + max(xmx[[i]]*x.multiplier)+xshift
    }
  }
  
  startheight <- max(concxs)
  if( dendro ){
    concxs<-c(concxs, shiftsum+max(xs)-min(xs))#xmx[[1]])
  }
  concxs<-c(-xshift,concxs)
  concxsrange<-max(concxs)-min(concxs)
  if(heatplot){
    indices<-sample(nys,nys,replace=FALSE)
    if( exp.names.on.plot ){
      ysrk<-rbind(ysrk,matrix(NA,floor(nys/20*3),dim(ysrk)[2]))
      indices<-c(indices,1:(floor(nys/20*3))+max(indices))
#      ysrk<-rbind(ysrk,matrix(NA,floor(nys/200*3)*numexps,dim(ysrk)[2]))
#      indices<-c(indices,1:(floor(nys/200*3)*numexps)+max(indices))
    } 
    if( horizontalplots ){
      image(1:(dim(ysrk[indices,])[1]),concxs,ysrk[indices,],xlab='Genes',ylab='Time',col=grred,axes=FALSE)
      vshft<-0-xshift
      if( exp.names.on.plot ){
        for( i in 1:(numexps-1) ){	
        if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
          vshft<-vshft+(xmaxs[i]*x.multiplier+xshift)
	  abline(h=vshft,,col="white")
#	  abline(h=i*xmax+(i-1)*xshift,,col="white")
	}
      }
      axis(side=1,at=c(1,nys),cex.axis=.7)
      axis(side=2,at=xmx[[1]],cex.axis=.7)
      shft<-nys*(1+numexps/200)
      shft<-dim(ysrk[indices,])[1]#right justify, with pos=2
#      shft<-nys#left justify, with pos=4,offset=1 #*(1+numexps/400)
       vshft<-0-xshift
      for( i in 1:numexps ){
        if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
        vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
        text(shft,vshft,expnames[i],srt=0,cex=1,pos=2)#srt=90,cex=.6)
        vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
      }
      image(1:(dim(ysrk)[1]),concxs,ysrk,xlab='Genes',ylab='Time',col=grred,axes=FALSE)
      shiftsum<-0-xshift
      for( i in 1:(numexps-1) ){
        if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
        shiftsum <- shiftsum + max(xmx[[i]]*x.multiplier)+xshift
        lines(c(0,nys+1),c(shiftsum,shiftsum),col="white")}
      if( dendro ){ clusterdendro<-F; source('s_dendrogram.R') }
      if( clusterlinesonimage ){
        numclusttot<-0+.5
        for( i in 1:(numclust/numexps-1) )
          {
            oldnumclusttot<-numclusttot
            numclusttot<-numclusttot+length(allys[(allys[,1] == ((i-1)*numexps+1)),1])
            lines(c(numclusttot,numclusttot),c(min(concxs),startheight),lwd=.5,col="white")
#            lines(c(numclusttot,numclusttot),c(-concxsrange/20,max(concxs)+concxsrange/20),lwd=.5,col="white")
                                        #          text((numclusttot+oldnumclusttot)/2,-3,paste(partic, paste(", Cluster ",i,sep=""),sep=""))
            axis(side=1,at=numclusttot,labels=FALSE,lwd=2)
            if( !dendro ){ axis(side=3,at=numclusttot,labels=FALSE,lwd=2) }
          }
        }

      axis(side=1,at=c(1,nys),cex.axis=.7)
      axis(side=2,at=xmx[[1]])
      shft<-nys*(1+numexps/200)
      shft<-dim(ysrk[indices,])[1]#right justify, with pos=2
#      shft<-nys#left justify, with pos=4,offset=1 #*(1+numexps/400)
      vshft<-0-xshift
      for( i in 1:numexps ){
        if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
        vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
        text(shft,vshft,expnames[i],srt=0,cex=1,pos=2)#srt=90,cex=.6)
        vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
      }
    }else{
      image(concxs,seq(from=1,to=nys,length=nys),t(ysrk[indices,]),ylab='Genes',xlab='Time',col=grred,axes=FALSE)
      for( i in 1:(numexps-1) ){
        lines(c(i*xmax+(i-1)*xshift,i*xmax+(i-1)*xshift),c(0,nys+1),col="white")}
      axis(side=2)
      axis(side=1,at=xmx[[1]])
      image(concxs,seq(from=1,to=nys,length=nys),t(ysrk),ylab='Genes',xlab='Time',col=grred,axes=FALSE)
      for( i in 1:(numexps-1) ){
        lines(c(i*xmax+(i-1)*xshift,i*xmax+(i-1)*xshift),c(0,nys+1),col="white")}

      if( clusterlinesonimage ){
        numclusttot<-0
        for( i in 1:(numclust/numexps-1) )
          {
            oldnumclusttot<-numclusttot
            numclusttot<-numclusttot+length(allys[(allys[,1] == ((i-1)*numexps+1)),1])*reps
            lines(c(min(concxs),startheight),c(numclusttot,numclusttot),lwd=1,col="white")
#            lines(c(-concxsrange/20,max(concxs)+concxsrange/20),c(numclusttot,numclusttot),lwd=1,col="white")
                                        #          text(-3,(numclusttot+oldnumclusttot)/2,paste(partic, paste(", Cluster ",i,sep=""),sep=""))
            axis(side=2,at=numclusttot,labels=FALSE,lwd=2)
            axis(side=4,at=numclusttot,labels=FALSE,lwd=2)
          }
      }
      
      axis(side=2)
      axis(side=1,at=xmx[[1]])
    }
  }
  if(plotclusteringimageseparately) dev.off()
}


medians<-quantiles[3,]
write(medians,paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_cluster_medians.dat",sep=""),ncolumns=length(medians)/(numclust/numexps))
write(quantiles,paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_cluster_quantiles.dat",sep=""),ncolumns=5)
if(medianplot){
  if(plotclusteringmediansseparately){
    png(paste(partic,"_cluster_medians.png",sep=""),height=900,width=1200)
  }
#  par(mar=c(4,4,1,0))
  mediansrk<-rank(medians)
  mediansrk[mediansrk>sum(!is.na(medians))]<-NA
  medianmx<-matrix(mediansrk,nrow=numclust/numexps,byrow=T)
  if( dendro ){ medianmx<-cbind(medianmx,matrix(NA,numclust/numexps,1))}
  if( exp.names.on.plot ){
    medianmx<-rbind(medianmx,matrix(NA,floor((numclust/numexps)/15*3),dim(medianmx)[2]))
  }
  image(.5:(dim(medianmx)[1]+.5),concxs,medianmx,xlab='Cluster',ylab='Time',main='Median Expression Levels',col=grred,axes=FALSE)
  if( exp.names.on.plot ){
    shft<-dim(medianmx)[1]+.5
    vshft<- -xshift
    for( i in 1:(numexps-1) ){	
      if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
      vshft<-vshft+(xmaxs[i]*x.multiplier+xshift)
      abline(h=vshft,,col="white")
    }
    vshft<-0-xshift
    for( i in 1:numexps ){
      if( !is.null(basis.powers) && basis.powers[i,2]==-1 ){x.multiplier<-20}else{x.multiplier<-1}
      vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
      text(shft,vshft,expnames[i],srt=0,cex=1,pos=2)#srt=90,cex=.6)
      vshft<-vshft+.5*(xmaxs[i]*x.multiplier+xshift)
    }
  }
  if( dendro ){ clusterdendro<-T; source('s_dendrogram.R'); clusterdendro<-F }
  axis(side=1,at=1:(numclust/numexps))
  axis(side=2,at=xmx[[1]])
  if(plotclusteringmediansseparately) dev.off()
}

if( bicplot ){
  if(plotbicseparately){
    png(paste(partic,"_bic_plot.png",sep=""),height=900,width=1200)
###  jpeg(paste(partic,"_bic_plot.jpg",sep=""),height=900,width=1200)
  }
  par(omi=c(0,0,0.5,0),mfrow=c(cols,rows) )
  missout<-0
  par(mfrow=c(1,1))
  numinplot<-(numclust/numexps-missout)*2/2*3
  mergers<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_mergerdetails_.dat",sep="")),byrow=T,ncol=7)
  numrows<-dim(mergers)[1]
  twocurves<-ifelse( !(numrows %% 2) && mergers[ numrows/2+1, 1 ] ==  mergers[ 1, 1 ], 1, 0 )
  threecurves<-ifelse( !(numrows %% 3) && mergers[ numrows/3+1, 1 ] ==  mergers[ 1, 1 ], 1, 0 )
  if( twocurves )numrows<-numrows/2
  if( threecurves )numrows<-numrows/3
  starting.row<-numrows-missout-numinplot+1
  bic<-mergers[starting.row:(numrows-missout),6]
  max.bic<-max(bic)
  min.bic<-min(bic)
  if( twocurves || threecurves ){
    bic2<-mergers[numrows+starting.row:(numrows-missout),6]
    max.bic<-max(c(max.bic,bic2))
    min.bic<-min(c(min.bic,bic2))
  }
  if( threecurves ){
    bic3<-mergers[2*numrows+starting.row:(numrows-missout),6]
    max.bic<-max(c(max.bic,bic3))
    min.bic<-min(c(min.bic,bic3))
  }
  ncs<-mergers[(numrows-missout-numinplot+1):(numrows-missout),1]
  plot(ncs,bic,pch=16,cex=.5,xlab='Number of clusters (C)',ylab='Log marginal likelihood',ylim=c(min.bic,max.bic))
  if( twocurves || threecurves )points(ncs,bic2,pch=5,cex=.5,col='blue')
  if( threecurves )points(ncs,bic3,pch=5,cex=.5,col='green')
  lines(c(numclust/numexps,numclust/numexps),c(2*min(bic)-max(bic),bic[(numrows-numclust/numexps-starting.row+2)]),col='red')
  text(numclust/numexps+numinplot/15,bic[ncs[numclust/numexps]]-(max.bic-min.bic)/5,paste('C=',numclust/numexps),col='red')
  if( twocurves || threecurves )lines(c(numclust/numexps,numclust/numexps),c(2*min.bic-max.bic,bic2[(numrows-numclust/numexps-starting.row+2)]),col='red',lty=2)
  if(plotbicseparately) dev.off()
}

if(associations){
  assoc.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_association_matrix_.dat",sep="")
  if( file.exists(assoc.file) ){
     library(fields)
     n<-dim(obsns)[1]
     assocs<-matrix(scan(assoc.file),byrow=T,nrow=n)
     if( dendro ){
        d<-scan(paste(partic,"_dendro_output_.dat",sep=""))
	assocs<-assocs[d,d]
     }
     for(j in 1:n){for(i in j:n){assocs[i,j]<-NA}}
     image.plot(1:n,1:n,assocs,zlim=c(0,1),xlab="Genes",ylab="Genes",main='Association probabilities',graphics.reset=TRUE,bty='l')
  }
}

if(crosscorrelations){
#  obsns<-matrix(t(allys[,2:(lxs+1)]),byrow=T,ncol=numexps*lxs)
  n<-dim(obsns)[1]
  correlation<-seq(0,0,n)
  correlationmx<-matrix(0,n,numexps*(numexps-1)/2)
  maxdens<--1
  counter<-0
  for( i in 1:(numexps-1) ){
    for( j in (i+1):numexps ){
      counter<-counter+1
#        perm<-sample(n)
      for( ii in 1:n ){
        v1<-obsns[ii,((i-1)*lxs+1):(i*lxs)]
        v2<-obsns[ii,((j-1)*lxs+1):(j*lxs)]
#          v2<-obsns[perm[ii],((j-1)*lxs+1):(j*lxs)]
        correlation[ii]<-sum(v1*v2)/sqrt(sum(v1*v1)*sum(v2*v2))#cor(v1,v2)
      }
      correlationmx[,counter]<-correlation
      maxdens<-max(maxdens,hist(correlation,freq=F,nclass=50,plot=F)$density)
    }
  }
  close.screen(all=TRUE)
  if( numexps <= 2 ){
  scrns<-split.screen(c(numexps-1,numexps-1))}
  else{
  scrns<-split.screen(c(numexps-2,numexps-1))}
  counter<-0
  cexsize<-1.4-.4
  for( i in 1:(numexps-1) ){
    for( j in (i+1):numexps ){
      counter<-counter+1
      correlation<-correlationmx[,counter]
      meancorr<-mean(correlation)
      mediancorr<-median(correlation)
#      screen( (i-1)*(numexps-2)+j-1 )
      screen( counter )
      hist(correlation,freq=F,nclass=50,main=NULL,xlab=NULL,ylab=NULL,ylim=c(0,maxdens),cex.axis=cexsize)
      lines(c(mediancorr,mediancorr),c(0,maxdens*.9),col='red')
      text(mediancorr,.95*maxdens,floor(mediancorr*1000)/1000,col='red',cex=cexsize)
      title(main=paste(paste(expnames[i],"vs"),expnames[j]),cex.main=cexsize,font.main=1)
#      title(main=expnames[j],cex.main=cexsize,font.main=1)
#      title(ylab=expnames[i],cex.lab=cexsize)
                                        #        title(main=paste('Experiment',j),cex.main=1,font.main=1)
#        title(ylab=paste('Experiment',i),cex=1)
    }
  }
  close.screen(all=TRUE)
  co<-sort(correlation)
  empcdf<-0
  empcdfx<-co[1]
  for(i in 1:(n-1) ){
    empcdf<-c(empcdf,i/n,i/n)
    empcdfx<-c(empcdfx,co[i],co[i+1])
  }
  empcdf<-c(empcdf,1)
  empcdfx<-c(empcdfx,co[n])
}
    
hist(ssq,nclass=100,col='lightblue')
numsteps<-5;
for( i in 1:numoutliersmarked ){
  stepdown<-numsteps*(i/numsteps-floor(i/numsteps))
  text(ssq[odr[i]],20+10*stepdown,paste("#",partition[odr[i]]),cex=.7,col='gold')
  lines(c(ssq[odr[i]],ssq[odr[i]]),c(0,10+10*stepdown),col='gold')
}

if( plotbayesfactors ){
  bfhist<-hist(logbayesfactors,nclass=100,col='lightgreen')
  bfscaler<-max(bfhist$counts)/250
  numsteps<-5;
for( i in 1:numoutliersmarked ){
  stepdown<-numsteps*(i/numsteps-floor(i/numsteps))
  text(logbayesfactors[odr2[i]],(20+10*stepdown)*bfscaler,paste("#",partition[odr2[i]]),cex=.7,col='red')
  lines(c(logbayesfactors[odr2[i]],logbayesfactors[odr2[i]]),c(0,(10+10*stepdown)*bfscaler),col='red')
  text(logbayesfactors[odr2[numobsns+1-i]],(20+10*stepdown)*bfscaler,paste("#",partition[odr2[numobsns+1-i]]),cex=.7,col='purple')
  lines(c(logbayesfactors[odr2[numobsns+1-i]],logbayesfactors[odr2[numobsns+1-i]]),c(0,(10+10*stepdown)*bfscaler),col='purple')
}
}

Residuals <- scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_residuals_.dat",sep=""))
hist(Residuals,nclass=100,freq=F,col='deeppink')
rs<-seq(min(Residuals),max(Residuals),length=200)
lines(rs,dnorm(rs,mean(Residuals),sd(Residuals)))

corrmx<-cor(obsns)
plot.experiment.time.point.correlations( corrmx )
title('Experiment Time Point Correlations')

expcorrs.file<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_exp_correlations_.dat",sep="")
if( numexps > 2 && file.exists(expcorrs.file) ){
  par(mar=c(5,2,4,2)+.1)
  library(fields)
  extra<- numexps/4
  expcorrs<-matrix(scan(expcorrs.file),byrow=T,ncol=numexps)
  for( j in 2:numexps ){ for( i in 1:(j-1) ){ expcorrs[i,j]<-NA }}
  image.plot(c(-extra,0:numexps),c(0:numexps,numexps+extra),cbind(rbind(rep(NA,numexps),expcorrs[,numexps:1]),rep(NA,numexps+1)),xlab="",ylab="",axes=F)#,col=heat.colors(100)))
  for( i in 1:numexps ){
    text((numexps-i)-extra/2,i-.5,expnames[numexps+1-i],cex=1)#.75)
    text(i-.5,numexps+extra/2,expnames[i],srt=90,cex=1)#.75)
  }
  title('Posterior Mean Experimental Correlations')
}

if( numexps > 2 )source('s_plot_locations.R')

source('s_plot_parameters.R')

if(plottofile)
{
  dev.off()
}
