three.d.plot<-!TRUE
pc1<-1
pc2<-2
pc3<-3
indep<-FALSE
partition.exp<-file.exists(paste(partic,"_exp_partition_.dat",sep=""))
partic<-scan("currentfile.txt", what=character())
corr.file<-paste(partic,"_exp_correlations_.dat",sep="")
if(file.exists(corr.file)){
  corrs<-scan(corr.file)
  corrows<-sqrt(length(corrs))
  for( i in 1:corrows ){ for( j in 1:corrows ){
    corrij <- corrs[ (i-1)*corrows+j ]
    if( ( i == j && corrij != 1 ) || ( i != j && corrij != 0 ) ){ indep<-FALSE }
}}
}

locs.file<-paste(partic,"_exp_locations_.dat",sep="")
if( !indep && file.exists(locs.file) ){
expnumbers.file<-paste(partic,"_exp_numbers_.dat",sep="")
if( file.exists(expnumbers.file) ){
  exps<-scan(expnumbers.file)
  numexps<-max(exps)
  minexps<-min(exps)
  if( minexps != numexps ){ numexps <- numexps - minexps + 1 }
}
expnames<-scan("allfiles.txt", what=character())
partition<-NULL

locs<-scan(locs.file)
means<-NULL
means.file<-paste(partic,"_exp_parameters_.dat",sep="")
if(file.exists(means.file)){ means<-scan(means.file) }
signs<-rep("red",numexps)
signs.file<-paste(partic,"_exp_signs_.dat",sep="")
if(file.exists(signs.file)){
  signs<-scan(signs.file)
  for( i in 1:length(signs) ){
    if( signs[i] == 1 ){signs[i]<-"red"}
    else{ signs[i]<-"blue" }
  }
}

if( partition.exp ){
  partition<-scan(paste(partic,"_exp_partition_.dat",sep=""))
  partition<-partition-min(partition)+1
  expcolors<-1:length(partition)
}

if(!is.null(partition) && max(partition) == 4){expcolors<-c(rgb(0,0,0),rgb(1,0.5,0.5),rgb(0.5,0,0.5),rgb(0,0,1))}

if(!is.null(partition)){
  pointcolors<-expcolors[partition]
  meancolors<-expcolors
}
else{
  pointcolors<-signs
  if( !is.null(means) ){
    meancolors<-rep(1,dim(means)[1])
  }
}

locs<-matrix(locs,byrow=T,nrow=numexps)
maxy<-max(locs[,pc2])
miny<-min(locs[,pc2])
maxx<-max(locs[,pc1])
minx<-min(locs[,pc1])
if( !is.null(means) ){
  means<-matrix(means,byrow=T,ncol=dim(locs)[2])
  maxy<-max(maxy,means[,pc2])
  miny<-min(miny,means[,pc2])
  maxx<-max(maxx,means[,pc1])
  minx<-min(minx,means[,pc1])
}
yrange<-maxy-miny
xrange<-maxx-minx
numcomps<-dim(locs)[2]
if( numcomps <= 2 ){ axislab <- "Axis" }else{ axislab <- "Principal Component" }
par(mfrow=c(1,1), mar=c(4,4,1,1))
if( !three.d.plot ){
  plot(locs[,pc1],locs[,pc2],xlab=paste(axislab,pc1),ylab=paste(axislab,pc2),ylim=c(miny-.1*yrange,maxy+.1*yrange),xlim=c(minx-.1*xrange,maxx+.1*xrange))
  if( maxy > 0 & miny < 0 & maxx > 0 & minx < 0 ){
#    abline(v=0,lwd=.25)
#    abline(h=0,lwd=.25)
  }
  for( i in 1:numexps )
    {
      text(locs[i,pc1],locs[i,pc2]-(1)^i*.0225*yrange,expnames[i],col=pointcolors[i],font=8)
    }
  if( !is.null(means) ){
    text(means[,pc1:pc2],expression(mu),col=meancolors,font=8)
  }
}
else{
  library(scatterplot3d)
  s3d<-scatterplot3d(locs[,pc1:pc3],xlab=paste(axislab,pc1),ylab=paste(axislab,pc2),zlab=paste(axislab,pc3),color=pointcolors,type='h',pch="")
  text(s3d$xyz.convert(locs[,pc1:pc3]),expnames,col=pointcolors,font=8)
  if( !is.null(means) ){
    s3d$points(means[,pc1:pc3],pch="",type="h",col=meancolors,lty="dashed")
    text(s3d$xyz.convert(means[,pc1:pc3]),expression(mu),col=meancolors,font=8)
  }
}

}
